define("time_utils",[],function(){var e;return e=function(){function e(){this.SECOND_MS=1e3,this.MINUTE_MS=this.SECOND_MS*60,this.HOUR_MS=this.MINUTE_MS*60,this.DAY_MS=this.HOUR_MS*24,this.WEEK_MS=this.DAY_MS*7,this.MONTH_MS=this.DAY_MS*30,this.YEAR_MS=this.DAY_MS*365}return e}(),new e}),function(){var e=Object.prototype.hasOwnProperty,t=function(t,n){function i(){this.constructor=t}for(var r in n)e.call(n,r)&&(t[r]=n[r]);return i.prototype=n.prototype,t.prototype=new i,t.__super__=n.prototype,t};define("chronos_error",[],function(){var e;return e=function(){function e(e){this.message=e}return t(e,Error),e.prototype.name="ChronosError",e}()})}.call(this),define("time_string",["./time_utils","./chronos_error"],function(e,t){var n;return n=function(){function r(e){var n;n=e.split(" "),this.quantity=parseInt(n[0]),this.unit=n[1];if(!/^\d+$/.test(this.quantity))throw new t("Unparseable time string")}var n;return n={ms:1,millisecond:1,mmilliseconds:1,s:e.SECOND_MS,second:e.SECOND_MS,seconds:e.SECOND_MS,m:e.MINUTE_MS,minute:e.MINUTE_MS,minutes:e.MINUTE_MS,h:e.HOUR_MS,hour:e.HOUR_MS,hours:e.HOUR_MS,d:e.DAY_MS,day:e.DAY_MS,days:e.DAY_MS,w:e.WEEK_MS,week:e.WEEK_MS,weeks:e.WEEK_MS,mo:e.MONTH_MS,month:e.MONTH_MS,months:e.MONTH_MS,y:e.YEAR_MS,year:e.YEAR_MS,years:e.YEAR_MS},r.prototype.toMilliseconds=function(){return this.quantity*n[this.unit]},r}()}),define("interval",["./time_string"],function(e){var t;return t=function(){function t(t){t.timeString&&(this.milliseconds=(new e(t.timeString)).toMilliseconds()),t.condition&&(this.condition=t.condition)}return t.prototype._setInterval=function(){var e,t=this;return this.milliseconds!=null&&this.callback!=null&&(e=this.condition!=null?function(){return t.condition()?clearInterval(t.interval):t.callback()}:this.callback,this.interval=setInterval(e,this.milliseconds)),this},t.prototype.every=function(t){return this.milliseconds=(new e(t)).toMilliseconds(),this._setInterval()},t.prototype["do"]=function(e){return this.callback=e,this._setInterval()},t}()}),define("timeout",["./time_string"],function(e){var t;return t=function(){function t(t){t.timeString&&(this.milliseconds=(new e(t.timeString)).toMilliseconds()),t.condition&&(this.condition=t.condition)}return t.prototype._setTimeout=function(){var e,t=this;return this.milliseconds!=null&&this.callback!=null&&(e=this.condition!=null?function(){return t.condition()?clearTimeout(t.timeout):t.callback()}:this.callback,this.timeout=setTimeout(e,this.milliseconds)),this},t.prototype["in"]=function(t){return this.milliseconds=(new e(t)).toMilliseconds(),this._setTimeout()},t.prototype["do"]=function(e){return this.callback=e,this._setTimeout()},t}()}),define("time_format",["./time_utils"],function(e){var t;return t=function(){function n(e){this.milliseconds=e}var t;return t=function(e,t,n){var r;return n=n==="future"?"from now":"ago",r=t>1?"s":"",""+t+" "+e+r+" "+n},n.prototype.format=function(){var n,r;return r=Date.now()-this.milliseconds,n=r<0?"future":"past",r=Math.abs(r),r<e.MINUTE_MS?t("second",Math.round(r/e.SECOND_MS),n):r<e.HOUR_MS?t("minute",Math.round(r/e.MINUTE_MS),n):r<e.DAY_MS?t("hour",Math.round(r/e.HOUR_MS),n):r<e.WEEK_MS?t("day",Math.round(r/e.DAY_MS),n):r<e.MONTH_MS?t("week",Math.round(r/e.WEEK_MS),n):r<e.YEAR_MS?t("month",Math.round(r/e.MONTH_MS),n):t("year",Math.round(r/e.YEAR_MS),n)},n}()}),define("chronos_dom",["./interval"],function(e){var t;return t=function(){function t(){}return t.prototype.element=function(e){var t,n;typeof e=="string"?(n=e[0]==="#"?e.substring(1,e.length):e,t=document.getElementById(n)):t=e;if(t==null)throw new Error("Element "+e+" not found");return t},t.prototype.setText=function(e,t){return typeof e.text=="function"?e.text(t):e.innerHTML=t},t.prototype.live=function(t,n,r,i){var s,o=this;return i==null&&(i="5 seconds"),s=this.element(t),this.setText(s,n(r)),(new e({timeString:i}))["do"](function(){return o.setText(s,n(r))})},t}(),new t}),define("chronos_time",["./time_string","./time_format","./chronos_dom"],function(e,t,n){var r;return r=function(){function r(e){this.dateObj=e}return r.prototype.toMilliseconds=function(){return this.dateObj.getTime()},r.prototype.getDateObject=function(){return this.dateObj},r.prototype.plus=function(t){return new r(new Date(this.toMilliseconds()+(new e(t)).toMilliseconds()))},r.prototype.minus=function(t){return new r(new Date(this.toMilliseconds()-(new e(t)).toMilliseconds()))},r.prototype.year=function(){return parseInt(this.dateObj.getFullYear())},r.prototype.month=function(){return parseInt(this.dateObj.getMonth())+1},r.prototype.day=function(){return parseInt(this.dateObj.getDate())},r.prototype.hour=function(){return parseInt(this.dateObj.getHours())},r.prototype.minute=function(){return parseInt(this.dateObj.getMinutes())},r.prototype.second=function(){return parseInt(this.dateObj.getSeconds())},r.prototype.millisecond=function(){return parseInt(this.dateObj.getMilliseconds())},r.prototype.toString=function(){return this.dateObj.toString()},r.prototype.timeAgo=function(){return(new t(this.toMilliseconds())).format()},r.prototype.timeFromNow=function(){return this.timeAgo()},r.prototype.live=function(e,t,r){return r==null&&(r="5 seconds"),n.live(e,t,this,r)},r}()}),function(){var e=Object.prototype.hasOwnProperty,t=function(t,n){function i(){this.constructor=t}for(var r in n)e.call(n,r)&&(t[r]=n[r]);return i.prototype=n.prototype,t.prototype=new i,t.__super__=n.prototype,t};define("relative_time_string",["./time_string"],function(e){var n;return n=function(){function n(e,t){var r;r=e.split(" "),this.direction=r[2]==="ago"?"past":"future",this.context=t,n.__super__.constructor.call(this,e)}return t(n,e),n.prototype.toMilliseconds=function(){var e;return e=n.__super__.toMilliseconds.apply(this,arguments),this.direction==="past"?this.context.toMilliseconds()-e:this.context.toMilliseconds()+e},n}()})}.call(this),define("time_parser",["./chronos_time","./chronos_error","./relative_time_string"],function(e,t,n){var r,i,s,o,u,a,f;return f=function(e){return Object.prototype.toString.call(e)==="[object String]"},a=function(e){return/^\d+$/.test(e)},r=function(){function e(e,r){var i,s;try{return r=r?[r]:[],s=new n(e,new u(r)),new u([s.toMilliseconds()])}catch(o){i=Date.parse(e);if(isNaN(i))throw new t("Unparseable language string: "+e);return new u([i])}}return e}(),o=function(){function t(t){return new e(t)}return t}(),i=function(){function e(e){return new o(new Date(e))}return e}(),s=function(){function e(e){var t;return t=new Date(e[0],e[1]-1||0,e[2]||1,e[3]||0,e[4]||0,e[5]||0,e[6]||0),new o(t)}return e}(),u=function(){function e(e){if(e.length===0)return o(new Date);if(e.length===1)return a(e[0])&&(""+e[0]).length===4?new s([e[0]]):a(e[0])?new i(e[0]):e[0]instanceof Date?new o(e[0]):new r(e[0]);if(e.length===2){if(a(e[0])&&(""+e[0]).length===4)return new s([e[0],e[1]]);if(f(e[0]))return new r(e[0],e[1]);throw new t("Invalid arguments: "+e)}return new s(e)}return e}()}),function(){var e=Array.prototype.slice;define("chronos",["./interval","./timeout","./time_parser"],function(t,n,r){return{"in":function(e){return new n({timeString:e})},every:function(e){return new t({timeString:e})},until:function(e){return new t({condition:e})},unless:function(e){return new n({condition:e})},"new":function(){var t;return t=1<=arguments.length?e.call(arguments,0):[],new r(t)}}})}.call(this);